/***************************************************************************
                          autoconfig.cpp  -  description
                             -------------------
    begin                : Mon Aug 5 2002
    copyright            : (C) 2002 by Morten Hustveit
    email                : mortehu@ifi.uio.no
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstringlist.h>

#include "configuration.h"

void Configuration::autoconfig()
{
  for(uint i = 0; i < 128; ++i)
  {
    _banks["0..127"][i] = QString("%1").arg(i);
    _banks["1..128"][i] = QString("%1").arg(i + 1);
  }

  _banks["General MIDI Instruments"][0] = "Acoustic Grand Piano";
  _banks["General MIDI Instruments"][1] = "Bright Acoustic Piano";
  _banks["General MIDI Instruments"][2] = "Electric Grand Piano";
  _banks["General MIDI Instruments"][3] = "Honky-tonk Piano";
  _banks["General MIDI Instruments"][4] = "Electric Piano 1";
  _banks["General MIDI Instruments"][5] = "Electric Piano 2";
  _banks["General MIDI Instruments"][6] = "Harpsichord";
  _banks["General MIDI Instruments"][7] = "Clavi";
  _banks["General MIDI Instruments"][8] = "Celesta";
  _banks["General MIDI Instruments"][9] = "Glockenspiel";
  _banks["General MIDI Instruments"][10] = "Music Box";
  _banks["General MIDI Instruments"][11] = "Vibraphone";
  _banks["General MIDI Instruments"][12] = "Marimba";
  _banks["General MIDI Instruments"][13] = "Xylophone";
  _banks["General MIDI Instruments"][14] = "Tubular Bells";
  _banks["General MIDI Instruments"][15] = "Dulcimer";
  _banks["General MIDI Instruments"][16] = "Drawbar Organ";
  _banks["General MIDI Instruments"][17] = "Percussive Organ";
  _banks["General MIDI Instruments"][18] = "Rock Organ";
  _banks["General MIDI Instruments"][19] = "Church Organ";
  _banks["General MIDI Instruments"][20] = "Reed Organ";
  _banks["General MIDI Instruments"][21] = "Accordion";
  _banks["General MIDI Instruments"][22] = "Harmonica";
  _banks["General MIDI Instruments"][23] = "Tango Accordion";
  _banks["General MIDI Instruments"][24] = "Acoustic Guitar (nylon)";
  _banks["General MIDI Instruments"][25] = "Acoustic Guitar (steel)";
  _banks["General MIDI Instruments"][26] = "Electric Guitar (jazz)";
  _banks["General MIDI Instruments"][27] = "Electric Guitar (clean)";
  _banks["General MIDI Instruments"][28] = "Electric Guitar (muted)";
  _banks["General MIDI Instruments"][29] = "Overdriven Guitar";
  _banks["General MIDI Instruments"][30] = "Distortion Guitar";
  _banks["General MIDI Instruments"][31] = "Guitar harmonics";
  _banks["General MIDI Instruments"][32] = "Acoustic Bass";
  _banks["General MIDI Instruments"][33] = "Electric Bass (finger)";
  _banks["General MIDI Instruments"][34] = "Electric Bass (pick)";
  _banks["General MIDI Instruments"][35] = "Fretless Bass";
  _banks["General MIDI Instruments"][36] = "Slap Bass 1";
  _banks["General MIDI Instruments"][37] = "Slap Bass 2";
  _banks["General MIDI Instruments"][38] = "Synth Bass 1";
  _banks["General MIDI Instruments"][39] = "Synth Bass 2";
  _banks["General MIDI Instruments"][40] = "Violin";
  _banks["General MIDI Instruments"][41] = "Viola";
  _banks["General MIDI Instruments"][42] = "Cello";
  _banks["General MIDI Instruments"][43] = "Contrabass";
  _banks["General MIDI Instruments"][44] = "Tremolo Strings";
  _banks["General MIDI Instruments"][45] = "Pizzicato Strings";
  _banks["General MIDI Instruments"][46] = "Orchestral Harp";
  _banks["General MIDI Instruments"][47] = "Timpani";
  _banks["General MIDI Instruments"][48] = "String Ensemble 1";
  _banks["General MIDI Instruments"][49] = "String Ensemble 2";
  _banks["General MIDI Instruments"][50] = "SynthStrings 1";
  _banks["General MIDI Instruments"][51] = "SynthStrings 2";
  _banks["General MIDI Instruments"][52] = "Choir Aahs";
  _banks["General MIDI Instruments"][53] = "Voice Oohs";
  _banks["General MIDI Instruments"][54] = "Synth Voice";
  _banks["General MIDI Instruments"][55] = "Orchestra Hit";
  _banks["General MIDI Instruments"][56] = "Trumpet";
  _banks["General MIDI Instruments"][57] = "Trombone";
  _banks["General MIDI Instruments"][58] = "Tuba";
  _banks["General MIDI Instruments"][59] = "Muted Trumpet";
  _banks["General MIDI Instruments"][60] = "French Horn";
  _banks["General MIDI Instruments"][61] = "Brass Section";
  _banks["General MIDI Instruments"][62] = "SynthBrass 1";
  _banks["General MIDI Instruments"][63] = "SynthBrass 2";
  _banks["General MIDI Instruments"][64] = "Soprano Sax";
  _banks["General MIDI Instruments"][65] = "Alto Sax";
  _banks["General MIDI Instruments"][66] = "Tenor Sax";
  _banks["General MIDI Instruments"][67] = "Baritone Sax";
  _banks["General MIDI Instruments"][68] = "Oboe";
  _banks["General MIDI Instruments"][69] = "English Horn";
  _banks["General MIDI Instruments"][70] = "Bassoon";
  _banks["General MIDI Instruments"][71] = "Clarinet";
  _banks["General MIDI Instruments"][72] = "Piccolo";
  _banks["General MIDI Instruments"][73] = "Flute";
  _banks["General MIDI Instruments"][74] = "Recorder";
  _banks["General MIDI Instruments"][75] = "Pan Flute";
  _banks["General MIDI Instruments"][76] = "Blown Bottle";
  _banks["General MIDI Instruments"][77] = "Shakuhachi";
  _banks["General MIDI Instruments"][78] = "Whistle";
  _banks["General MIDI Instruments"][79] = "Ocarina";
  _banks["General MIDI Instruments"][80] = "Lead 1 (square)";
  _banks["General MIDI Instruments"][81] = "Lead 2 (sawtooth)";
  _banks["General MIDI Instruments"][82] = "Lead 3 (calliope)";
  _banks["General MIDI Instruments"][83] = "Lead 4 (chiff)";
  _banks["General MIDI Instruments"][84] = "Lead 5 (charang)";
  _banks["General MIDI Instruments"][85] = "Lead 6 (voice)";
  _banks["General MIDI Instruments"][86] = "Lead 7 (fifths)";
  _banks["General MIDI Instruments"][87] = "Lead 8 (bass + lead)";
  _banks["General MIDI Instruments"][88] = "Pad 1 (new age)";
  _banks["General MIDI Instruments"][89] = "Pad 2 (warm)";
  _banks["General MIDI Instruments"][90] = "Pad 3 (polysynth)";
  _banks["General MIDI Instruments"][91] = "Pad 4 (choir)";
  _banks["General MIDI Instruments"][92] = "Pad 5 (bowed)";
  _banks["General MIDI Instruments"][93] = "Pad 6 (metallic)";
  _banks["General MIDI Instruments"][94] = "Pad 7 (halo)";
  _banks["General MIDI Instruments"][95] = "Pad 8 (sweep)";
  _banks["General MIDI Instruments"][96] = "FX 1 (rain)";
  _banks["General MIDI Instruments"][97] = "FX 2 (soundtrack)";
  _banks["General MIDI Instruments"][98] = "FX 3 (crystal)";
  _banks["General MIDI Instruments"][99] = "FX 4 (atmosphere)";
  _banks["General MIDI Instruments"][100] = "FX 5 (brightness)";
  _banks["General MIDI Instruments"][101] = "FX 6 (goblins)";
  _banks["General MIDI Instruments"][102] = "FX 7 (echoes)";
  _banks["General MIDI Instruments"][103] = "FX 8 (sci-fi)";
  _banks["General MIDI Instruments"][104] = "Sitar";
  _banks["General MIDI Instruments"][105] = "Banjo";
  _banks["General MIDI Instruments"][106] = "Shamisen";
  _banks["General MIDI Instruments"][107] = "Koto";
  _banks["General MIDI Instruments"][108] = "Kalimba";
  _banks["General MIDI Instruments"][109] = "Bag pipe";
  _banks["General MIDI Instruments"][110] = "Fiddle";
  _banks["General MIDI Instruments"][111] = "Shanai";
  _banks["General MIDI Instruments"][112] = "Tinkle Bell";
  _banks["General MIDI Instruments"][113] = "Agogo";
  _banks["General MIDI Instruments"][114] = "Steel Drums";
  _banks["General MIDI Instruments"][115] = "Woodblock";
  _banks["General MIDI Instruments"][116] = "Taiko Drum";
  _banks["General MIDI Instruments"][117] = "Melodic Tom";
  _banks["General MIDI Instruments"][118] = "Synth Drum";
  _banks["General MIDI Instruments"][119] = "Reverse Cymbal";
  _banks["General MIDI Instruments"][120] = "Guitar Fret Noise";
  _banks["General MIDI Instruments"][121] = "Breath Noise";
  _banks["General MIDI Instruments"][122] = "Seashore";
  _banks["General MIDI Instruments"][123] = "Bird Tweet";
  _banks["General MIDI Instruments"][124] = "Telephone Ring";
  _banks["General MIDI Instruments"][125] = "Helicopter";
  _banks["General MIDI Instruments"][126] = "Applause";
  _banks["General MIDI Instruments"][127] = "Gunshot";

  _notes["General MIDI Drum Set"][34] = "Acoustic Bass Drum";
  _notes["General MIDI Drum Set"][35] = "Bass Drum 1";
  _notes["General MIDI Drum Set"][36] = "Side Stick";
  _notes["General MIDI Drum Set"][37] = "Acoustic Snare";
  _notes["General MIDI Drum Set"][38] = "Hand Clap";
  _notes["General MIDI Drum Set"][39] = "Electric Snare";
  _notes["General MIDI Drum Set"][40] = "Low Floor Tom";
  _notes["General MIDI Drum Set"][41] = "Closed Hi-Hat";
  _notes["General MIDI Drum Set"][42] = "High Floor Tom";
  _notes["General MIDI Drum Set"][43] = "Pedal Hi-Hat";
  _notes["General MIDI Drum Set"][44] = "Low Tom";
  _notes["General MIDI Drum Set"][45] = "Open Hi-Hat";
  _notes["General MIDI Drum Set"][46] = "Low-Mid Tom";
  _notes["General MIDI Drum Set"][47] = "Hi-Mid Tom";
  _notes["General MIDI Drum Set"][48] = "Crash Cymbal 1";
  _notes["General MIDI Drum Set"][49] = "High Tom";
  _notes["General MIDI Drum Set"][50] = "Ride Cymbal 1";
  _notes["General MIDI Drum Set"][51] = "Chinese Cymbal";
  _notes["General MIDI Drum Set"][52] = "Ride Bell";
  _notes["General MIDI Drum Set"][53] = "Tambourine";
  _notes["General MIDI Drum Set"][54] = "Splash Cymbal";
  _notes["General MIDI Drum Set"][55] = "Cowbell";
  _notes["General MIDI Drum Set"][56] = "Crash Cymbal 2";
  _notes["General MIDI Drum Set"][57] = "Vibraslap";
  _notes["General MIDI Drum Set"][58] = "Ride Cymbal 2";
  _notes["General MIDI Drum Set"][59] = "Hi Bongo";
  _notes["General MIDI Drum Set"][60] = "Low Bongo";
  _notes["General MIDI Drum Set"][61] = "Mute Hi Conga";
  _notes["General MIDI Drum Set"][62] = "Open Hi Conga";
  _notes["General MIDI Drum Set"][63] = "Low Conga";
  _notes["General MIDI Drum Set"][64] = "High Timbale";
  _notes["General MIDI Drum Set"][65] = "Low Timbale";
  _notes["General MIDI Drum Set"][66] = "High Agogo";
  _notes["General MIDI Drum Set"][67] = "Low Agogo";
  _notes["General MIDI Drum Set"][68] = "Cabasa";
  _notes["General MIDI Drum Set"][69] = "Maracas";
  _notes["General MIDI Drum Set"][70] = "Short Whistle";
  _notes["General MIDI Drum Set"][71] = "Long Whistle";
  _notes["General MIDI Drum Set"][72] = "Short Guiro";
  _notes["General MIDI Drum Set"][73] = "Long Guiro";
  _notes["General MIDI Drum Set"][74] = "Claves";
  _notes["General MIDI Drum Set"][75] = "Hi Wood Block";
  _notes["General MIDI Drum Set"][76] = "Low Wood Block";
  _notes["General MIDI Drum Set"][77] = "Mute Cuica";
  _notes["General MIDI Drum Set"][78] = "Open Cuica";
  _notes["General MIDI Drum Set"][79] = "Mute Triangle";
  _notes["General MIDI Drum Set"][80] = "Open Triangle";

  _instruments["Generic"].setBank(-1, "0..127");

  _instruments["General MIDI"].setBank(0, "General MIDI Instruments");
  _instruments["General MIDI"].setBank(-1, "0..127");

  _instruments["General MIDI Drums"].setBank(-1, "0..127");
  _instruments["General MIDI Drums"].setKeys(-1, -1, "General MIDI Drum Set");
  _instruments["General MIDI Drums"].setDrums(-1, -1, true);

  int ALSAPortCount = 0;
  int RawPortCount = 0;

  for(PortInfos::const_iterator port = _portInfos.begin(); port != _portInfos.end(); ++port)
  {
    if((*port).type == PortInfo::ALSA)
      ++ALSAPortCount;
    else if((*port).type == PortInfo::Raw)
      ++RawPortCount;
  }

  if(ALSAPortCount)
  {
    PortInfos::const_iterator port;

    for(port = _portInfos.begin(); port != _portInfos.end(); ++port)
    {
      if((*port).type != PortInfo::ALSA)
        continue;

      _ports.resize(_ports.size() + 1);
      _ports.insert(_ports.size() - 1, new Port(*port));
    }
  }
  else if(RawPortCount)
  {
    PortInfos::const_iterator port;

    for(port = _portInfos.begin(); port != _portInfos.end(); ++port)
    {
      if((*port).type != PortInfo::Raw)
        continue;

      _ports.resize(_ports.size() + 1);
      _ports.insert(_ports.size() - 1, new Port(*port));
    }
  }
}

