/***************************************************************************
                          sanetrackerview.h  -  description
                             -------------------
    begin                : Sat Jun  8 15:33:59 CEST 2002
    copyright            : (C) 2002 by Morten Hustveit
    email                : mortehu@ifi.uio.no
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SANETRACKERVIEW_H
#define SANETRACKERVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qwidget.h>

class QSplitter;
class QVBoxLayout;
class SanetrackerDoc;
class Configuration;
class Sequence;
class Scheduler;
class Pattern;
class Piano;

class SanetrackerView : public QWidget
{
Q_OBJECT

  friend class SanetrackerApp;
  friend class Scheduler;
  friend class Sequence;
  friend class Pattern;

public:

  SanetrackerView(QWidget* parent, const Configuration*, Scheduler&);
  ~SanetrackerView();

  SanetrackerDoc* getDocument() const;

  void reconfigure();

  void edit(uint device, uint pattern, uint position);

public slots:

  void positionChanged();

protected:

  QSplitter*   splitter;
  QVBoxLayout* vLayout;
  Sequence*    sequence;
  Pattern*     pattern;
  Piano*       piano;
  const Configuration* config;
  Scheduler& scheduler;
  int          lastFocus;

protected:

  bool event(QEvent*);

protected slots:

  void sequenceActivated();
  void patternActivated();
};

#endif // SANETRACKERVIEW_H

